Index: modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/model/document/Status.java
===================================================================
--- modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/model/document/Status.java	(revision 57157)
+++ modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/model/document/Status.java	(revision 57158)
@@ -5,16 +5,10 @@
  */
 public enum Status {
 
-	/**
-	 * The marked.
-	 */
+	/** The marked. */
 	MARKED,
-	/**
-	 * The error.
-	 */
+	/** The error. */
 	ERROR,
-	/**
-	 * The ok.
-	 */
+	/** The ok. */
 	OK
 }
Index: modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/model/document/IndexDocument.java
===================================================================
--- modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/model/document/IndexDocument.java	(revision 57157)
+++ modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/model/document/IndexDocument.java	(revision 57158)
@@ -10,27 +10,32 @@
 	/**
 	 * Adds a field with the given name, value and boost. If a field with the name already exists, then the given value is appended to the
 	 * value of that field, with the new boost. If the value is a collection, then each of its values will be added to the field.
-	 * <p>
+	 * 
 	 * The class type of value and the name parameter should match schema.xml. schema.xml can be found in conf directory under the solr home
 	 * by default.
-	 *
-	 * @param name  Name of the field, should match one of the field names defined under "fields" tag in schema.xml.
-	 * @param value Value of the field, should be of same class type as defined by "type" attribute of the corresponding field in schema.xml.
+	 * 
+	 * @param name
+	 *            Name of the field, should match one of the field names defined under "fields" tag in schema.xml.
+	 * @param value
+	 *            Value of the field, should be of same class type as defined by "type" attribute of the corresponding field in schema.xml.
 	 */
 	public void addField(String name, Object value);
 
 	/**
 	 * Set a field with implied null value for boost.
-	 *
-	 * @param name  name of the field to set
-	 * @param value value of the field
+	 * 
+	 * @param name
+	 *            name of the field to set
+	 * @param value
+	 *            value of the field
 	 */
 	public void setField(String name, Object value);
 
 	/**
 	 * Get the first value for a field.
-	 *
-	 * @param name name of the field to fetch
+	 * 
+	 * @param name
+	 *            name of the field to fetch
 	 * @return first value of the field or null if not present
 	 */
 	public Object getFieldValue(String name);
@@ -37,8 +42,9 @@
 
 	/**
 	 * Gets the field.
-	 *
-	 * @param field the field
+	 * 
+	 * @param field
+	 *            the field
 	 * @return the field
 	 */
 	public IndexField getField(String field);
@@ -45,8 +51,9 @@
 
 	/**
 	 * Remove a field from the document.
-	 *
-	 * @param name The field name whose field is to be removed from the document
+	 * 
+	 * @param name
+	 *            The field name whose field is to be removed from the document
 	 * @return the previous field with <tt>name</tt>, or <tt>null</tt> if there was no field for <tt>key</tt>.
 	 */
 	public IndexField removeField(String name);
@@ -53,8 +60,9 @@
 
 	/**
 	 * Get all the values for a field.
-	 *
-	 * @param name name of the field to fetch
+	 * 
+	 * @param name
+	 *            name of the field to fetch
 	 * @return value of the field or null if not set
 	 */
 	public Collection<Object> getFieldValues(String name);
@@ -61,7 +69,7 @@
 
 	/**
 	 * Get all field names.
-	 *
+	 * 
 	 * @return Set of all field names.
 	 */
 	public Collection<String> getFieldNames();
@@ -68,7 +76,7 @@
 
 	/**
 	 * return a copy of index Document.
-	 *
+	 * 
 	 * @return the index document
 	 */
 	public IndexDocument deepCopy();
@@ -75,7 +83,7 @@
 
 	/**
 	 * Gets the status.
-	 *
+	 * 
 	 * @return the status
 	 */
 	public Status getStatus();
@@ -82,8 +90,9 @@
 
 	/**
 	 * The set status.
-	 *
-	 * @param status the status
+	 * 
+	 * @param status
+	 *            the status
 	 * @return the index document
 	 */
 	public IndexDocument setStatus(Status status);
@@ -90,7 +99,7 @@
 
 	/**
 	 * If there was an error building the document, it is described here.
-	 *
+	 * 
 	 * @return the error
 	 */
 	public Throwable getError();
@@ -97,8 +106,9 @@
 
 	/**
 	 * Sets the error.
-	 *
-	 * @param error the error
+	 * 
+	 * @param error
+	 *            the error
 	 * @return the index document
 	 */
 	public IndexDocument setError(final Throwable error);
@@ -105,7 +115,7 @@
 
 	/**
 	 * Sets the ok status to the index document.
-	 *
+	 * 
 	 * @return the index document
 	 */
 	public IndexDocument setOK();
@@ -112,7 +122,7 @@
 
 	/**
 	 * Sets the status marked to the index document.
-	 *
+	 * 
 	 * @return the index document
 	 */
 	public IndexDocument setMarked();
Index: modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/model/document/AbstractIndexDocument.java
===================================================================
--- modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/model/document/AbstractIndexDocument.java	(revision 57157)
+++ modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/model/document/AbstractIndexDocument.java	(revision 57158)
@@ -1,29 +1,36 @@
 package eu.dnetlib.clients.index.model.document;
 
-import java.util.*;
+import java.util.Collection;
+import java.util.Iterator;
+import java.util.LinkedHashMap;
+import java.util.Map;
+import java.util.Set;
 
 import eu.dnetlib.clients.index.model.Any.ValueType;
 import eu.dnetlib.clients.index.utils.IndexFieldUtility;
 
+
 /**
  * The Class AbstractDocument Represent the field information needed to construct and index Document.
  */
 public abstract class AbstractIndexDocument implements Map<String, IndexField>, Iterable<IndexField>, IndexDocument {
 
+	/** The _fields. */
+	protected final Map<String, IndexField> fields;
+
 	private static final String DATE_SUFFIX = "\\+\\d{2}:\\d{2}";
+
 	/**
-	 * The _fields.
+	 * Actual document status.
 	 */
-	protected final Map<String, IndexField> fields;
+	private Status status;
+
 	/**
 	 * index schema.
 	 */
 	protected final Map<String, ValueType> schema;
+
 	/**
-	 * Actual document status.
-	 */
-	private Status status;
-	/**
 	 * If there was an error building the document, it is described here.
 	 */
 	private Throwable error;
@@ -33,13 +40,15 @@
 	 */
 	public AbstractIndexDocument(final Map<String, ValueType> schema, final String dsId) {
 		this.schema = schema;
-		fields = new LinkedHashMap<>();
+		fields = new LinkedHashMap<String, IndexField>();
+		// addField(IndexFieldUtility.DS_ID, dsId);
 	}
 
 	/**
 	 * Instantiates a new abstract document.
 	 *
-	 * @param fields the fields
+	 * @param fields
+	 *            the fields
 	 */
 	public AbstractIndexDocument(final Map<String, ValueType> schema, final String dsId, final Map<String, IndexField> fields) {
 		this.schema = schema;
@@ -59,10 +68,15 @@
 
 	/**
 	 * {@inheritDoc}
+	 *
+	 * @see eu.dnetlib.index.model.document.IndexDocument#addField(java.lang.String, java.lang.Object)
 	 */
 	@Override
 	public void addField(final String name, final Object value) {
 		Object hack_value = hackField(name, value);
+		if (hack_value==null) {
+			return;
+		}
 		IndexField field = fields.get(name);
 		if ((field == null) || (field.getValue() == null)) {
 			setField(name, hack_value);
@@ -73,6 +87,8 @@
 
 	/**
 	 * {@inheritDoc}
+	 *
+	 * @see eu.dnetlib.index.model.document.IndexDocument#getFieldValue(java.lang.String)
 	 */
 	@Override
 	public Object getFieldValue(final String name) {
@@ -86,6 +102,8 @@
 
 	/**
 	 * {@inheritDoc}
+	 *
+	 * @see eu.dnetlib.index.model.document.IndexDocument#getField(java.lang.String)
 	 */
 	@Override
 	public IndexField getField(final String field) {
@@ -94,6 +112,8 @@
 
 	/**
 	 * {@inheritDoc}
+	 *
+	 * @see eu.dnetlib.index.model.document.IndexDocument#getFieldValues(java.lang.String)
 	 */
 	@Override
 	public Collection<Object> getFieldValues(final String name) {
@@ -104,6 +124,8 @@
 
 	/**
 	 * {@inheritDoc}
+	 *
+	 * @see eu.dnetlib.index.model.document.IndexDocument#getFieldNames()
 	 */
 	@Override
 	public Collection<String> getFieldNames() {
@@ -112,6 +134,8 @@
 
 	/**
 	 * {@inheritDoc}
+	 *
+	 * @see eu.dnetlib.index.model.document.IndexDocument#setField(java.lang.String, java.lang.Object)
 	 */
 	@Override
 	public void setField(final String name, final Object value) {
@@ -123,6 +147,8 @@
 
 	/**
 	 * {@inheritDoc}
+	 *
+	 * @see eu.dnetlib.index.model.document.IndexDocument#removeField(java.lang.String)
 	 */
 	@Override
 	public IndexField removeField(final String name) {
@@ -132,7 +158,7 @@
 	/**
 	 * {@inheritDoc}
 	 *
-	 * @see Iterable#iterator()
+	 * @see java.lang.Iterable#iterator()
 	 */
 	@Override
 	public Iterator<IndexField> iterator() {
@@ -142,7 +168,7 @@
 	/**
 	 * {@inheritDoc}
 	 *
-	 * @see Object#toString()
+	 * @see java.lang.Object#toString()
 	 */
 	@Override
 	public String toString() {
@@ -156,7 +182,7 @@
 	/**
 	 * {@inheritDoc}
 	 *
-	 * @see Map#containsKey(Object)
+	 * @see java.util.Map#containsKey(java.lang.Object)
 	 */
 	@Override
 	public boolean containsKey(final Object key) {
@@ -166,7 +192,7 @@
 	/**
 	 * {@inheritDoc}
 	 *
-	 * @see Map#containsValue(Object)
+	 * @see java.util.Map#containsValue(java.lang.Object)
 	 */
 	@Override
 	public boolean containsValue(final Object value) {
@@ -176,7 +202,7 @@
 	/**
 	 * {@inheritDoc}
 	 *
-	 * @see Map#entrySet()
+	 * @see java.util.Map#entrySet()
 	 */
 	@Override
 	public Set<Entry<String, IndexField>> entrySet() {
@@ -186,7 +212,7 @@
 	/**
 	 * {@inheritDoc}
 	 *
-	 * @see Map#get(Object)
+	 * @see java.util.Map#get(java.lang.Object)
 	 */
 	@Override
 	public IndexField get(final Object key) {
@@ -196,7 +222,7 @@
 	/**
 	 * {@inheritDoc}
 	 *
-	 * @see Map#isEmpty()
+	 * @see java.util.Map#isEmpty()
 	 */
 	@Override
 	public boolean isEmpty() {
@@ -206,7 +232,7 @@
 	/**
 	 * {@inheritDoc}
 	 *
-	 * @see Map#keySet()
+	 * @see java.util.Map#keySet()
 	 */
 	@Override
 	public Set<String> keySet() {
@@ -216,7 +242,7 @@
 	/**
 	 * {@inheritDoc}
 	 *
-	 * @see Map#put(Object, Object)
+	 * @see java.util.Map#put(java.lang.Object, java.lang.Object)
 	 */
 	@Override
 	public IndexField put(final String key, final IndexField value) {
@@ -226,7 +252,7 @@
 	/**
 	 * {@inheritDoc}
 	 *
-	 * @see Map#putAll(Map)
+	 * @see java.util.Map#putAll(java.util.Map)
 	 */
 	@Override
 	public void putAll(final Map<? extends String, ? extends IndexField> t) {
@@ -236,7 +262,7 @@
 	/**
 	 * {@inheritDoc}
 	 *
-	 * @see Map#remove(Object)
+	 * @see java.util.Map#remove(java.lang.Object)
 	 */
 	@Override
 	public IndexField remove(final Object key) {
@@ -246,7 +272,7 @@
 	/**
 	 * {@inheritDoc}
 	 *
-	 * @see Map#size()
+	 * @see java.util.Map#size()
 	 */
 	@Override
 	public int size() {
@@ -256,7 +282,7 @@
 	/**
 	 * {@inheritDoc}
 	 *
-	 * @see Map#values()
+	 * @see java.util.Map#values()
 	 */
 	@Override
 	public Collection<IndexField> values() {
@@ -265,6 +291,8 @@
 
 	/**
 	 * {@inheritDoc}
+	 *
+	 * @see eu.dnetlib.index.model.document.IndexDocument#getStatus()
 	 */
 	@Override
 	public Status getStatus() {
@@ -274,7 +302,8 @@
 	/**
 	 * Sets the status.
 	 *
-	 * @param status the status to set
+	 * @param status
+	 *            the status to set
 	 * @return the index document
 	 */
 	@Override
@@ -285,6 +314,8 @@
 
 	/**
 	 * {@inheritDoc}
+	 *
+	 * @see eu.dnetlib.index.model.document.IndexDocument#deepCopy()
 	 */
 	@Override
 	public IndexDocument deepCopy() {
@@ -294,6 +325,8 @@
 
 	/**
 	 * {@inheritDoc}
+	 *
+	 * @see eu.dnetlib.index.model.document.IndexDocument#getError()
 	 */
 	@Override
 	public Throwable getError() {
@@ -303,6 +336,8 @@
 
 	/**
 	 * {@inheritDoc}
+	 *
+	 * @see eu.dnetlib.index.model.document.IndexDocument#setOK()
 	 */
 	@Override
 	public IndexDocument setOK() {
@@ -312,6 +347,8 @@
 
 	/**
 	 * {@inheritDoc}
+	 *
+	 * @see eu.dnetlib.index.model.document.IndexDocument#setMarked()
 	 */
 	@Override
 	public IndexDocument setMarked() {
@@ -321,6 +358,8 @@
 
 	/**
 	 * {@inheritDoc}
+	 *
+	 * @see eu.dnetlib.index.model.document.IndexDocument#setError(java.lang.Throwable)
 	 */
 	@Override
 	public IndexDocument setError(final Throwable error) {
@@ -339,10 +378,11 @@
 		if (schema == null) return value;
 
 		final ValueType type = schema.get(name);
-		if(type == null){
-			throw new NullPointerException("cannot find index field "+name+" in schema");
+
+		if (type==null) {
+			return null;
 		}
-
+		
 		// TODO: hack this is hardcoded for the date type
 		switch (type) {
 		case DATETIME:
Index: modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/model/document/IndexField.java
===================================================================
--- modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/model/document/IndexField.java	(revision 57157)
+++ modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/model/document/IndexField.java	(revision 57158)
@@ -9,30 +9,42 @@
  */
 public class IndexField implements Iterable<Object> {
 
-	/**
-	 * The name.
-	 */
+	/** The name. */
 	private String name;
 
-	/**
-	 * The value.
-	 */
+	/** The value. */
 	private Object value = null;
 
-	/**
-	 * Instantiates a new index field.
-	 *
-	 * @param n the n
-	 */
 	public IndexField(final String n) {
 		this.name = n;
 	}
 
 	/**
+	 * Set the value for a field. Arrays will be converted to a collection. If a collection is given, then that collection will be used as
+	 * the backing collection for the values.
+	 * 
+	 * @param v
+	 *            the v
+	 */
+	public void setValue(final Object v) {
+
+		if (v instanceof Object[]) {
+			Object[] arr = (Object[]) v;
+			Collection<Object> c = new ArrayList<Object>(arr.length);
+			for (Object o : arr) {
+				c.add(o);
+			}
+			value = c;
+		} else {
+			value = v;
+		}
+	}
+
+	/**
 	 * Add values to a field. If the added value is a collection, each value will be added individually.
-	 *
-	 * @param v the v
-	 * @param b the b
+	 * 
+	 * @param v
+	 *            the v
 	 */
 	@SuppressWarnings("unchecked")
 	public void addValue(final Object v) {
@@ -74,7 +86,7 @@
 
 	/**
 	 * Gets the first value.
-	 *
+	 * 
 	 * @return the first value
 	 */
 	@SuppressWarnings("unchecked")
@@ -90,7 +102,7 @@
 
 	/**
 	 * Gets the value.
-	 *
+	 * 
 	 * @return the value for this field. If the field has multiple values, this will be a collection.
 	 */
 	public Object getValue() {
@@ -98,29 +110,8 @@
 	}
 
 	/**
-	 * Set the value for a field. Arrays will be converted to a collection. If a collection is given, then that collection will be used as
-	 * the backing collection for the values.
-	 *
-	 * @param v the v
-	 * @param b the b
-	 */
-	public void setValue(final Object v) {
-
-		if (v instanceof Object[]) {
-			Object[] arr = (Object[]) v;
-			Collection<Object> c = new ArrayList<Object>(arr.length);
-			for (Object o : arr) {
-				c.add(o);
-			}
-			value = c;
-		} else {
-			value = v;
-		}
-	}
-
-	/**
 	 * Gets the values.
-	 *
+	 * 
 	 * @return the values for this field. This will return a collection even if the field is not multi-valued
 	 */
 	@SuppressWarnings("unchecked")
@@ -136,7 +127,7 @@
 
 	/**
 	 * Gets the value count.
-	 *
+	 * 
 	 * @return the number of values for this field
 	 */
 	@SuppressWarnings("rawtypes")
@@ -150,7 +141,7 @@
 
 	/**
 	 * Gets the name.
-	 *
+	 * 
 	 * @return the name
 	 */
 	public String getName() {
@@ -159,8 +150,9 @@
 
 	/**
 	 * Sets the name.
-	 *
-	 * @param name the new name
+	 * 
+	 * @param name
+	 *            the new name
 	 */
 	public void setName(final String name) {
 		this.name = name;
@@ -168,8 +160,8 @@
 
 	/**
 	 * {@inheritDoc}
-	 *
-	 * @see Iterable#iterator()
+	 * 
+	 * @see java.lang.Iterable#iterator()
 	 */
 	@Override
 	@SuppressWarnings({ "unchecked", "rawtypes" })
@@ -199,8 +191,8 @@
 
 	/**
 	 * {@inheritDoc}
-	 *
-	 * @see Object#toString()
+	 * 
+	 * @see java.lang.Object#toString()
 	 */
 	@Override
 	public String toString() {
Index: modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/utils/IndexFieldUtility.java
===================================================================
--- modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/utils/IndexFieldUtility.java	(revision 57157)
+++ modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/utils/IndexFieldUtility.java	(revision 57158)
@@ -2,8 +2,9 @@
 
 /**
  * IndexMap keeps track of IndexDataStructure-to-physical index mappings and vice-versa.
- *
+ * 
  * @author claudio
+ * 
  */
 public class IndexFieldUtility {
 
Index: modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/utils/ServiceTools.java
===================================================================
--- modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/utils/ServiceTools.java	(revision 57157)
+++ modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/utils/ServiceTools.java	(revision 57158)
@@ -42,7 +42,7 @@
 	public MetadataReference getMetadataRef(final String dsId) throws IndexServiceException {
 
 		final String xquery = "for $x in //RESOURCE_PROFILE[.//RESOURCE_IDENTIFIER/@value='" + dsId + "']//CONFIGURATION " + "return concat("
-				+ "$x/METADATA_FORMAT/text(),'@'," + "$x/METADATA_FORMAT_LAYOUT/text(),'@'," + "$x/METADATA_FORMAT_INTERPRETATION/text())";
+				+ "$x/METADATA_FORMAT/text(),'-'," + "$x/METADATA_FORMAT_LAYOUT/text(),'-'," + "$x/METADATA_FORMAT_INTERPRETATION/text())";
 		return mdFactory.decodeMetadata(getResourceProfileByQuery(xquery));
 	}
 
@@ -81,7 +81,7 @@
 	private List<String> listMDRefsAsString() throws IndexClientException {
 		final String xquery = "for $x in //RESOURCE_PROFILE[.//RESOURCE_TYPE/@value='MDFormatDSResourceType'] "
 				+ "let $format:= $x//CONFIGURATION/NAME/string() " + "for $y in $x//LAYOUTS/LAYOUT " + "let $layout:= $y/@name/string() "
-				+ "let $interpretation:= $x//CONFIGURATION/INTERPRETATION/text() " + "return concat($format,'@',$layout,'@',$interpretation) ";
+				+ "let $interpretation:= $x//CONFIGURATION/INTERPRETATION/text() " + "return concat($format,'-',$layout,'-',$interpretation) ";
 		return quickSearchProfile(xquery);
 	}
 
@@ -167,4 +167,4 @@
 			throw new IndexServiceException(e);
 		}
 	}
-}
+}
\ No newline at end of file
Index: modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/utils/MDFormatReader.java
===================================================================
--- modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/utils/MDFormatReader.java	(revision 57157)
+++ modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/utils/MDFormatReader.java	(revision 57158)
@@ -12,23 +12,54 @@
 
 import com.google.common.collect.HashBasedTable;
 import com.google.common.collect.Table;
+import com.mycila.xmltool.CallBack;
 import com.mycila.xmltool.XMLDoc;
+import com.mycila.xmltool.XMLTag;
 
 import eu.dnetlib.clients.index.client.IndexClientException;
+import eu.dnetlib.rmi.provision.IndexServiceException;
 import eu.dnetlib.utils.MetadataReference;
+import eu.dnetlib.utils.MetadataReferenceFactory;
 
+
 public class MDFormatReader {
 
+	static class XmlUtils {
+
+		/**
+		 * helper method, parses a list of fields.
+		 *
+		 * @param fields
+		 *            the given fields
+		 * @return the parsed fields
+		 * @throws IndexServiceException
+		 *             if cannot parse the fields
+		 */
+		public static Document parse(final String xml) {
+			try {
+				return new SAXReader().read(new StringReader(xml));
+			} catch (DocumentException e) {
+				throw new IllegalArgumentException("cannot parse: " + xml);
+			}
+		}
+
+		public static InputSource asInputSource(final String input) throws DocumentException {
+			return new InputSource(new StringReader(parse(input).asXML()));
+		}
+	}
+
 	@Autowired
 	private ServiceTools serviceTools;
 
-	// @Autowired
+	@Autowired
+	private MetadataReferenceFactory mdFactory;
+
 	public List<MetadataReference> listMDRefs() throws IndexClientException {
 		return serviceTools.listMDRefs();
 	}
 
 	public Document getFields(final MetadataReference mdRef) {
-		final String fields = serviceTools.getIndexFields(mdRef);
+		String fields = serviceTools.getIndexFields(mdRef);
 		return (fields != null) && !fields.isEmpty() ? XmlUtils.parse(fields) : null;
 	}
 
@@ -39,56 +70,37 @@
 	public Table<String, String, String> getAttributeTable(final MetadataReference mdRef, final String... attributeList) throws IndexClientException {
 
 		final String fields = serviceTools.getIndexFields(mdRef);
-		if (fields.isEmpty()) { throw new IndexClientException("No result getting index layout informations"); }
+		if (fields.isEmpty()) throw new IndexClientException("No result getting index layout informations");
 		final Table<String, String, String> t = HashBasedTable.create();
-		XMLDoc.from(serviceTools.getIndexFields(mdRef), false).forEach("//FIELD", field -> {
+		XMLDoc.from(serviceTools.getIndexFields(mdRef), false).forEach("//FIELD", new CallBack() {
 
-			for (final String attribute : attributeList) {
-				String value = null;
+			@Override
+			public void execute(final XMLTag field) {
 
-				if ("xpath".equals(attribute)) {
-					if (!(field.hasAttribute("xpath") || field.hasAttribute("value"))) { return; }
+				for (String attribute : attributeList) {
+					String value = null;
 
-					value = field.hasAttribute("xpath") ? field.getAttribute("xpath") : field.getAttribute("value");
-				}
+					if ("xpath".equals(attribute)) {
+						if (!(field.hasAttribute("xpath") || field.hasAttribute("value"))) return;
 
-				if ("weight".equals(attribute)) {
-					if (!(field.hasAttribute(attribute))) { return; }
+						value = field.hasAttribute("xpath") ? field.getAttribute("xpath") : field.getAttribute("value");
+					}
 
-					value = field.hasAttribute(attribute) ? field.getAttribute(attribute) : "";
-				}
+					if ("weight".equals(attribute)) {
+						if (!(field.hasAttribute(attribute))) return;
 
-				if (value == null) {
-					value = field.getAttribute(attribute);
+						value = field.hasAttribute(attribute) ? field.getAttribute(attribute) : "";
+					}
+
+					if (value == null) {
+						value = field.getAttribute(attribute);
+					}
+
+					t.put(field.getAttribute("name").toLowerCase(), attribute, value);
 				}
-
-				t.put(field.getAttribute("name").toLowerCase(), attribute, value);
 			}
 		});
 		return t;
 	}
 
-	static class XmlUtils {
-
-		/**
-		 * helper method, parses a list of fields.
-		 * <p>
-		 * <p>
-		 * the given fields
-		 *
-		 * @return the parsed fields if cannot parse the fields
-		 */
-		public static Document parse(final String xml) {
-			try {
-				return new SAXReader().read(new StringReader(xml));
-			} catch (final DocumentException e) {
-				throw new IllegalArgumentException("cannot parse: " + xml);
-			}
-		}
-
-		public static InputSource asInputSource(final String input) throws DocumentException {
-			return new InputSource(new StringReader(parse(input).asXML()));
-		}
-	}
-
 }
Index: modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/query/QueryResponseParser.java
===================================================================
--- modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/query/QueryResponseParser.java	(revision 57157)
+++ modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/query/QueryResponseParser.java	(revision 57158)
@@ -6,53 +6,63 @@
 
 import com.google.common.collect.BiMap;
 import com.google.common.collect.Iterables;
+
 import eu.dnetlib.clients.index.model.document.IndexDocument;
 import eu.dnetlib.clients.index.utils.IndexFieldUtility;
 import eu.dnetlib.rmi.provision.BrowsingRow;
 
+
 /**
  * The Class QueryResponseParser.
  */
 public abstract class QueryResponseParser {
 
-	/**
-	 * The highlight utils.
-	 */
+	/** The highlight utils. */
 	protected final Function<String, String> highlightUtils;
 
-	/**
-	 * The aliases.
-	 */
+	/** The aliases. */
 	protected final BiMap<String, String> aliases;
 
-	/**
-	 * The return empty fields.
-	 */
+	/** The return empty fields. */
 	protected final boolean returnEmptyFields;
 
-	/**
-	 * The include ranking.
-	 */
+	/** The include ranking. */
 	protected final boolean includeRanking;
 
-	/**
-	 * The wrapper rank.
-	 */
+	/** The wrapper rank. */
 	protected final Function<IndexDocument, String> wrapperRank =
 			doc -> addRanking(getSingleField(doc, IndexFieldUtility.RESULT), getSingleField(doc, IndexFieldUtility.SCORE_FIELD));
 
+	/** The wrapper no rank. */
+	protected final Function<IndexDocument, String> wrapperNoRank = doc -> wrap(getSingleField(doc, IndexFieldUtility.RESULT));
+
 	/**
-	 * The wrapper no rank.
+	 * Gets the single field.
+	 *
+	 * @param doc
+	 *            the doc
+	 * @param fieldName
+	 *            the field name
+	 * @return the single field
 	 */
-	protected final Function<IndexDocument, String> wrapperNoRank = doc -> wrap(getSingleField(doc, IndexFieldUtility.RESULT));
+	@SuppressWarnings("unchecked")
+	private String getSingleField(final IndexDocument doc, final String fieldName) {
+		Object value = doc.getFieldValue(fieldName);
+		if (value instanceof Collection) return Iterables.getOnlyElement((Iterable<String>) value);
+		return String.valueOf(value);
+	}
 
 	/**
 	 * Instantiates a new query response parser.
 	 *
-	 * @param highlightUtils    the highlight utils
-	 * @param aliases           the aliases
-	 * @param returnEmptyFields the return empty fields
-	 * @param includeRanking    the include ranking
+	 * @param highlightUtils
+	 *            the highlight utils
+	 * @param aliases
+	 *            the aliases
+	 * @param returnEmptyFields
+	 *            the return empty fields
+	 * @param includeRanking
+	 *            the include ranking
 	 */
 	public QueryResponseParser(final Function<String, String> highlightUtils, final BiMap<String, String> aliases, final boolean returnEmptyFields,
 			final boolean includeRanking) {
@@ -64,26 +74,14 @@
 	}
 
 	/**
-	 * Gets the single field.
+	 * Converts a String document to
 	 *
-	 * @param doc       the doc
-	 * @param fieldName the field name
-	 * @return the single field
-	 */
-	@SuppressWarnings("unchecked")
-	private String getSingleField(final IndexDocument doc, final String fieldName) {
-		Object value = doc.getFieldValue(fieldName);
-		if (value instanceof Collection) return Iterables.getOnlyElement((Iterable<String>) value);
-		return String.valueOf(value);
-	}
-
-	/**
-	 * Converts a String document to
-	 * <p>
 	 * <record rank="score"> [document] </record>.
 	 *
-	 * @param doc   the doc
-	 * @param score the score
+	 * @param doc
+	 *            the doc
+	 * @param score
+	 *            the score
 	 * @return the string
 	 */
 	private String addRanking(final String doc, final String score) {
@@ -93,7 +91,8 @@
 	/**
 	 * Wraps the given document as <record> [document] </record>.
 	 *
-	 * @param doc the doc
+	 * @param doc
+	 *            the doc
 	 * @return the string
 	 */
 	private String wrap(final String doc) {
Index: modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/query/BrowseAliases.java
===================================================================
--- modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/query/BrowseAliases.java	(revision 57157)
+++ modules/dnet-core-components/branches/saxonHE-SOLR-772/src/main/java/eu/dnetlib/clients/index/query/BrowseAliases.java	(revision 57158)
@@ -3,21 +3,25 @@
 import java.util.List;
 import java.util.Map;
 
+import org.apache.commons.logging.Log;
+import org.apache.commons.logging.LogFactory;
+import org.dom4j.Document;
+import org.dom4j.Element;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.beans.factory.annotation.Required;
+
 import com.google.common.collect.BiMap;
 import com.google.common.collect.HashBiMap;
 import com.google.common.collect.Maps;
+
 import eu.dnetlib.clients.index.client.IndexClientException;
 import eu.dnetlib.clients.index.utils.IndexFieldUtility;
 import eu.dnetlib.clients.index.utils.MDFormatReader;
+import eu.dnetlib.clients.index.utils.ServiceTools;
+import eu.dnetlib.rmi.provision.IndexServiceException;
 import eu.dnetlib.utils.MetadataReference;
-import eu.dnetlib.clients.index.utils.ServiceTools;
-import org.apache.commons.logging.Log;
-import org.apache.commons.logging.LogFactory;
-import org.dom4j.Document;
-import org.dom4j.Element;
-import org.springframework.beans.factory.annotation.Autowired;
-import org.springframework.beans.factory.annotation.Required;
 
+
 /**
  * The Class BrowseAliases.
  */
@@ -28,9 +32,7 @@
 	 */
 	private static final Log log = LogFactory.getLog(BrowseAliases.class); // NOPMD
 
-	/**
-	 * The aliases.
-	 */
+	/** The aliases. */
 	private Map<MetadataReference, BiMap<String, String>> aliases = Maps.newConcurrentMap();
 
 	private ServiceTools serviceTools;
@@ -40,8 +42,9 @@
 
 	/**
 	 * Initialize.
-	 * <p>
-	 * the index service exception
+	 * 
+	 * @throws IndexServiceException
+	 *             the index service exception
 	 */
 	public void initialize() throws IndexClientException {
 		log.info("initializing browse aliases");
@@ -54,8 +57,9 @@
 
 	/**
 	 * Put.
-	 *
-	 * @param mdRef the metadata refeference
+	 * 
+	 * @param mdRef
+	 *            the metadata refeference
 	 */
 	public void put(final MetadataReference mdRef) {
 		final Document fields = mdFormatReader.getFields(mdRef);
@@ -70,8 +74,9 @@
 
 	/**
 	 * Gets the.
-	 *
-	 * @param mdRef the md ref
+	 * 
+	 * @param mdRef
+	 *            the md ref
 	 * @return browsing aliases for given mdRef.
 	 * @throws IndexClientException
 	 */
@@ -84,8 +89,9 @@
 
 	/**
 	 * Method extract aliases field names from the given fields.
-	 *
-	 * @param fields the fields
+	 * 
+	 * @param fields
+	 *            the fields
 	 * @return aliases map. Keys are "normal" field names, values are names of the non-tokenized version of the field
 	 */
 	protected BiMap<String, String> extractBrowsingAliases(final Document fields) {
@@ -117,7 +123,8 @@
 	}
 
 	/**
-	 * @param serviceTools the serviceTools to set
+	 * @param serviceTools
+	 *            the serviceTools to set
 	 */
 	@Required
 	public void setServiceTools(final ServiceTools serviceTools) {
